function satel(massa_tgt,x_tgt,y_tgt,z_tgt,vx_tgt,vy_tgt,vz_tgt,...
    massa_int,x_int,y_int,z_int,vx_int,vy_int,vz_int,...
    massa_sat,x_sat,y_sat,z_sat,vx_sat,vy_sat,vz_sat,...
    dT_iter,iteraz, dT);
% PLANET Simulazione dell'interazione tra pianeti

% Inizializzazione del campo grafico di disegno
f=figure;
set(f,'Renderer','Zbuffer',...
    'Units','norm',...
    'pos',[0.05 0.48 0.5 0.45],...
    'Color',[.6 .6 .6]);
axh_sim=axes('Box','on',...
    'DrawMode','Fast',...
    'DataAspectRatio',[1, 1, 1],...
    'Position',[0.05 0.05 0.9 0.9],...
    'Color',[0 0 0],...
    'XColor',[1 1 1],...
    'YColor',[1 1 1],...
    'ZColor',[1 1 1]);
view([-45 45]);
axis equal
xlabel('asse X ()');
ylabel('asse Y ()');
zlabel('asse Z ()');
hold on

f=figure;
set(f,'Renderer','Zbuffer',...    
    'Units','norm',...
    'pos',[0.05 0 0.5 0.45],...
    'Color',[.6 .6 .6]);
axh_sat=axes('Box','on',...
    'DrawMode','Fast',...
    'DataAspectRatio',[1, 1, 1],...
    'Position',[0.05 0.05 0.9 0.9],...
    'Color',[0 0 0],...
    'XColor',[1 1 1],...
    'YColor',[1 1 1],...
    'ZColor',[1 1 1]);
view([-45 45]);
axis equal
xlabel('asse X ()');
ylabel('asse Y ()');
zlabel('asse Z ()');
hold on

% Inizializzazione variabili
G = 6.67259e-11; % N * m^2 / kg^2

% Centri del TARGET e dell'INTRUDER
axes(axh_sim);
bersaglio = plot3(x_tgt,y_tgt,z_tgt,'Marker','.','MarkerSize',40,'Color',[1 1 0]);
intruso = plot3(x_int,y_int,z_int,'Marker','.','MarkerSize',20,'Color',[0 0 1]);
satellite = plot3(x_sat,y_sat,z_sat,'Marker','.','MarkerSize',5,'Color',[.8 .8 .8]);
axes(axh_sat);
intruso_sat = plot3(x_int-x_int, y_int-y_int, z_int-z_int,'Marker','.','MarkerSize',40,'Color',[0 0 1]);
satellite_sat = plot3(x_sat-x_int, y_sat-y_int, z_sat-z_int,'Marker','.','MarkerSize',10,'Color',[.9 .9 .9]);

drawnow

% In prima approssimazione possiamo dire che per calcolare la posizione
% di un pianeta che ha posizione iniziale (x0, y0, z0):
% x1=x0+u0*dT
% y1=y0+v0*dT
% z1=z0+w0*dT
% Dato il calcolo delle velocita' a partire dalle forze di interazione
% scambiate tra i corpi e le velocita' iniziali (u0, v0, w0):
% u1=u0+Fx*dT
% v1=v0+Fy*dT
% w1=w0+Fz*dT

for j=1:iteraz
    for k=1:dT_iter
        % Calcolo dei parametri del calcolo
        opt1 = x_tgt - x_int;
        opt2 = y_tgt - y_int;
        opt3 = z_tgt - z_int;
        opt4 = (opt1^2 + opt2^2 + opt3^2 + 1e9)^1.5;
        opt5 = x_tgt - x_sat;
        opt6 = y_tgt - y_sat;
        opt7 = z_tgt - z_sat;
        opt8 = (opt5^2 + opt6^2 + opt7^2 + 1e9)^1.5;
        opt9 = x_int - x_sat;
        opt10 = y_int - y_sat;
        opt11 = z_int - z_sat;
        opt12 = (opt9^2 + opt10^2 + opt11^2 + 1e8)^1.5;
        % Calcolo della velocita' del centro del pianeta TARGET
        vx_tgt = vx_tgt - G*massa_int*opt1/opt4*dT - G*massa_sat*opt5/opt8*dT;
        vy_tgt = vy_tgt - G*massa_int*opt2/opt4*dT - G*massa_sat*opt6/opt8*dT;
        vz_tgt = vz_tgt - G*massa_int*opt3/opt4*dT - G*massa_sat*opt7/opt8*dT;
        % Calcolo della velocita' del centro del pianeta INTRUDER
        vx_int = vx_int + G*massa_tgt*opt1/opt4*dT - G*massa_sat*opt9/opt12*dT;
        vy_int = vy_int + G*massa_tgt*opt2/opt4*dT - G*massa_sat*opt10/opt12*dT;
        vz_int = vz_int + G*massa_tgt*opt3/opt4*dT - G*massa_sat*opt11/opt12*dT;
        % Calcolo della velocita' del centro del SATELLITE
        vx_sat = vx_sat + G*massa_tgt*opt5/opt8*dT + G*massa_int*opt9/opt12*dT;
        vy_sat = vy_sat + G*massa_tgt*opt6/opt8*dT + G*massa_int*opt10/opt12*dT;
        vz_sat = vz_sat + G*massa_tgt*opt7/opt8*dT + G*massa_int*opt11/opt12*dT;
        % Aggiornamento della posizione del centro del pianeta TARGET
        x_tgt = x_tgt + vx_tgt*dT;
        y_tgt = y_tgt + vy_tgt*dT;
        z_tgt = z_tgt + vz_tgt*dT;
        % Aggiornamento della posizione del centro del pianeta INTRUDER
        x_int = x_int + vx_int*dT;
        y_int = y_int + vy_int*dT;
        z_int = z_int + vz_int*dT;
        % Aggiornamento della posizione del centro del SATELLITE
        x_sat = x_sat + vx_sat*dT;
        y_sat = y_sat + vy_sat*dT;
        z_sat = z_sat + vz_sat*dT;
        % Disegno della traiettoria dei centri dei pianeti
        axes(axh_sim);
        line([x_tgt-vx_tgt*dT x_tgt],[y_tgt-vy_tgt*dT y_tgt],[z_tgt-vz_tgt*dT z_tgt],'Color',[1 1 0],'linewidth',2);
        line([x_int-vx_int*dT x_int],[y_int-vy_int*dT y_int],[z_int-vz_int*dT z_int],'Color',[1 1 0],'linewidth',2);
        line([x_sat-vx_sat*dT x_sat],[y_sat-vy_sat*dT y_sat],[z_sat-vz_sat*dT z_sat],'Color',[0 1 1],'linewidth',1);
        axes(axh_sat);
        line([x_sat-vx_sat*dT-(x_int-vx_int*dT) x_sat-x_int],...
            [y_sat-vy_sat*dT-(y_int-vy_int*dT) y_sat-y_int],...
            [z_sat-vz_sat*dT-(z_int-vz_int*dT) z_sat-z_int],'Color',[0 1 1]);
    end
    % Varizione della posizione dei centri dei pianeti
    axes(axh_sim);
    set(bersaglio,'XData',x_tgt,'YData',y_tgt,'ZData',z_tgt);
    set(intruso,'XData',x_int,'YData',y_int,'ZData',z_int);
    set(satellite,'XData',x_sat,'YData',y_sat,'ZData',z_sat);
    % Calcolo del tempo trascorso
    tempo=(j-1)*dT_iter+k;
    % Aggiornamento delle visualizzazione
    title(['Tempo: ',num2str(tempo),' /',num2str(iteraz*dT_iter)]);
    daspect([1 1 1/100]);
    % Visualizzazione rispetto al pianeta
    axes(axh_sat);
    set(intruso_sat,'XData',x_int-x_int,'YData',y_int-y_int,'ZData',z_int-z_int);
    set(satellite_sat,'XData',x_sat-x_int,'YData',y_sat-y_int,'ZData',z_sat-z_int);
    % Calcolo del tempo trascorso
    tempo=(j-1)*dT_iter+k;
    % Aggiornamento delle visualizzazione
    title(['Tempo: ',num2str(tempo),' /',num2str(iteraz*dT_iter)]);
    daspect([1 1 1/2]);
    drawnow
end