% Inizializzazione variabili
%clear all
% Massa del SOLE
mtarget = 2e30;         % kg
% Posizione SOLE
posxtgt = 0;            % m
posytgt = 0;            % m
posztgt = 0;            % m
% Velocita' SOLE
velxtgt = 0;            % m/s
velytgt = 0;            % m/s
velztgt = 0;            % m/s

% Massa TERRA
mintruso = 5.98e24;     % kg
% Posizione TERRA
posxint = 150e9;        % m
posyint = 0;            % m
poszint = 0;            % m
% Velocita' TERRA
velxint = 0;            % m/s
velyint = 2*pi*posxint/(365*24*60^2);  % m/s
velzint = 0;            % m/s

% LUNA
% L'orbita lunare e' inclinata di circa 5 gradi rispetto al
% piano dell'eclittica
rad = 2*pi * 5/360; % Radianti corrispondenti a 5 gradi
% Massa LUNA
massa_luna = mintruso/81;  % kg
% Posizione LUNA
dist = 384.4e6;         % m
posxsat = posxint + dist;
posysat = 0;            % m
poszsat = 0;            % m
% Velocita' LUNA
vel = 2*pi*dist/(27*24*60^2+8*60^2);  % m/s
velxsat = 0;            % m/s
velysat = velyint + vel*cos(rad); % m/s
velzsat = vel*sin(rad); % m/s

% Numero di iterazioni
iter = 365;
% Numero di deltaT per ogni iterazione
deltaT_iter = 24;
% Passo temporale
deltaT = 3600;

tic
% Lancio dell'algoritmo
satel(mtarget, posxtgt, posytgt, posztgt, velxtgt, velytgt, velztgt,...
    mintruso, posxint, posyint, poszint, velxint, velyint, velzint,...
    massa_luna,posxsat,posysat,poszsat,velxsat,velysat,velzsat,...
    deltaT_iter, iter, deltaT);
toc