/***************************************************************************
                             deflist.h  -  Lista delle definizioni
                             -------------------------------------
    begin                : thu jun 6 11:00:36 CET 2000
    copyright            : (C) 2000 by Marco Giovannini
    email                : 
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#ifndef DEFLIST_H
#define DEFLIST_H

#include <string.h>
#include <malloc.h>
#include "slist.h"

#define Definition DefList::Def

class DefList
{
public:
class Def
{
public:
    Def(char* def_id=NULL, char* def_val=NULL);
    ~Def(void);

    char* getName(void)         { return id; }
    void setName(char* name)    { if (id) free(id); id=strdup(name); }
    char* getValue(void)        { return val; }
    void setValue(char* value)  { if (val) free(val); val=strdup(value); }
    void catValue(char* value);
    DefList* getParamList(void) { return params; }

    void addParam(Definition* param) { params->add(param); }

    int operator ==(Definition& e) { return !strcmp(id,e.getName()); }

private:
    char*    id;
    char*    val;
    DefList* params;
};

public:
    void add(Definition* def)    { list.enqueue(def); }
    void remove(Definition* def) { list.erase(def); }
    Definition* search(char* id);

private:
    SList<Definition> list;
};

inline Definition::Def(char* def_id, char* def_val)
{
    id=val=NULL;
    if (def_id) setName(def_id); else id=NULL;
    if (def_val) setValue(def_val); else setValue("1");
    params=new DefList;
}

inline Definition::~Def(void)
{
    if (id) free(id);
    free(val);
    delete params;
}

inline void Definition::catValue(char* value)
{
    if (char* tmp=(char*)malloc(strlen(val)+strlen(value)+1)) {
        strcpy(tmp,val);
        strcat(tmp,value);
        free(val);
        val=tmp;
    }
}

inline Definition* DefList::search(char* id)
{
    Definition tmp(id);
	return list.search(&tmp);
}

#endif
