/***************************************************************************
                             preproc.h  -  Preprocessore C
                             -----------------------------------
    begin                : thu jun 6 11:00:36 CET 2000
    copyright            : (C) 2000 by Marco Giovannini
    email                : 
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#ifndef PREPROC_H
#define PREPROC_H

#include "ppc.h"
#include "deflist.h"
#include "token.h"

class PreProcessor
{
public:
    PreProcessor(FILE* dst_file, PPCError* err, DefList* defs=NULL);
    int start(char* in);

private:
    int  processFile(FILE* src_file);
    int  processLine(int line);

    int  processWord(char* word);
    int  processDirective(char* dir);
    int  processDefinition(char* def_name);

    int  processDefine(void);
    void continueDefine(Definition* def, char* value);
    int  processUndef(void);
    int  processIfdef(void);
    int  processIfndef(void);
    int  processElse(void);
    int  processEndif(void);
    int  processInclude(void);

    FILE*       dst;
    DefList*    dl;
    Tokenizer   tok;
    PPCError*   error;
    Definition* last_def;
    int         if_flag, in_if, in_cmt;
    char        last;
};

#endif
