/***************************************************************************
                             slist.h  -  Template di liste
                             -----------------------------------
    begin                : thu jun 6 11:00:36 CET 2000
    copyright            : (C) 2000 by Marco Giovannini
    email                : 
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

//
// Una SList e' una lista che puo' anche essere usata come stack.
//

#ifndef SLIST_H
#define SLIST_H

#ifndef NULL
#define NULL 0
#endif

template <class Type>
class SList
{
    class SListNode
    {
    public:
        SListNode(void)                 { SLN_data=NULL; SLN_next=NULL; }
        SListNode* getNext(void)        { return SLN_next; }
        void setNext(SListNode* next)   { SLN_next=next; }
        Type* getData(void)             { return SLN_data; }
        void setData(Type* elem)        { SLN_data=elem; }
    private:
        Type*      SLN_data;
        SListNode* SLN_next;
    };

public:
    SList(void)                { head=tail=NULL; }
    ~SList(void)               { while (Type* tmp=pop()) delete tmp; }

    int empty(void)            { return !head; }
    Type* front(void)          { return empty()?NULL:head->getData(); }

    void push(Type* elem);
    Type* pop(void);

    void enqueue(Type* elem);
    Type* dequeue(void)        { return pop(); }

    void moveToFront(Type* elem);
    void erase(Type* elem)     { moveToFront(elem); pop(); }

    Type* search(Type* elem);

private:
    void push(SListNode* e) { e->setNext(head); if (empty()) tail=e; head=e; }

    SListNode* head;
    SListNode* tail;
};

template <class Type>
void SList<Type>::push(Type* elem)
{
    if (elem) {
        SListNode* tmp=new SListNode;
        tmp->setData(elem);
        push(tmp);
    }
}

template <class Type>
Type* SList<Type>::pop(void)
{
    Type* elem=NULL;
    if (!empty()) {
        SListNode* tmp=head;
        elem=head->getData();
        head=head->getNext();
        if (empty()) tail=NULL;
        delete tmp;
    }
    return elem;
}

template <class Type>
void SList<Type>::enqueue(Type* elem)
{
    if (elem) {
        SListNode* tmp=new SListNode;
        tmp->setData(elem);
        if (empty()) head=tmp;
        else tail->setNext(tmp);
        tail=tmp;
    }
}

template <class Type>
void SList<Type>::moveToFront(Type* elem)
{
    if (elem) {
        SListNode* tmp=head;
        SListNode* next;
        if (!tmp || tmp->getData()==elem) return;
        while ((next=tmp->getNext()) && next->getData()!=elem)
            tmp=next;
        if (next) {
            tmp->setNext(next->getNext());
            push(next);
        }
    }
}

template <class Type>
Type* SList<Type>::search(Type* elem)
{
    if (elem && !empty()) {
        SListNode* tmp=head;
        while (tmp && !(*elem==*(tmp->getData())))
            tmp=tmp->getNext();
        if (tmp) return tmp->getData();
    }
    return NULL;
};

#endif
