//******************************************************************//
//                                                                  //                                                                  //
//       TSpuntoROBOTHand    Delphi 6 Application      Ver 1.0      //
//       Copyright 2003 Luca Spuntoni                Jun. 2003      //
//       spuntosoft@tiscali.it                                      //
//                                                                  //                                                                  //
//******************************************************************//
unit SpuntoROBOT_Hand_Unit1;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls,Forms,Buttons,
  Dialogs, ExtCtrls, Menus, StdCtrls, SpuntoLedComponent, UnitPortaParallela,
  UnitAbout, Spin, Math, jpeg;

type

//**************************  Main Class  ***********************************//

  TSpuntoROBOTHandForm = class(TForm)
    StepperMotorPanel: TPanel;
    MainMenu1: TMainMenu;
    Files1: TMenuItem;
    Exit1: TMenuItem;
    ParallelManager1: TMenuItem;
    ShowManager1: TMenuItem;
    About1: TMenuItem;
    Label1: TLabel;
    Label2: TLabel;
    MoveHandCheckBox: TCheckBox;
    DirectionGroupBox: TGroupBox;
    OpenRadioButton: TRadioButton;
    CloseRadioButton: TRadioButton;
    ContinuousMonitoringCheckBox: TCheckBox;
    Image1: TImage;
    Image2: TImage;
    Image3: TImage;
    Timer1: TTimer;
    procedure ShowManager1Click(Sender: TObject);
    procedure Exit1Click(Sender: TObject);
    procedure About1Click(Sender: TObject);
    procedure FormShow(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure HandAction;
    procedure StopHand;
    procedure CloseHand;
    procedure OpenHand;
    procedure DelaytoStepTimerTimer(Sender: TObject);
    procedure ContinuousMonitoringCheckBoxClick(Sender: TObject);
    procedure WritePort(PortAddress, PortData:word);
    procedure MoveHandCheckBoxClick(Sender: TObject);
    procedure OpenRadioButtonDblClick(Sender: TObject);
    procedure CloseRadioButtonClick(Sender: TObject);
    procedure Timer1Timer(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  SpuntoROBOTHandForm: TSpuntoROBOTHandForm;
   
implementation

{$R *.dfm}

procedure TSpuntoROBOTHandForm.ShowManager1Click(Sender: TObject);
begin
 ContinuousMonitoringCheckBox.Checked:=True;
 FormPortaParallela.Show;
 FormPortaParallela.StepperMotorPortaParallela.SpuntoContinuousMonitoring:=ContinuousMonitoringCheckBox.Checked;
end;

procedure TSpuntoROBOTHandForm.Exit1Click(Sender: TObject);
begin
SpuntoRobotHandForm.Close;
end;

procedure TSpuntoROBOTHandForm.About1Click(Sender: TObject);
begin
SpuntoAbout.ShowModal;
end;

procedure TSpuntoROBOTHandForm.FormShow(Sender: TObject);
begin
SpuntoAbout.ShowModal;
end;

procedure TSpuntoROBOTHandForm.FormCreate(Sender: TObject);
Var
 I:Integer;
 V:Variant;
 S:String;
begin
 //Inizializzazione Stato dei componenti sulla Form principale
  MoveHandCheckBox.Checked:=False;
  ContinuousMonitoringCheckBox.Checked:=False;
  CloseRadioButton.Checked:=True;
end;

procedure TSpuntoROBOTHandForm.HandAction;    // Controls the ROBOT's Hand
Begin
        If MoveHandCheckBox.Checked then begin
           If CloseRadioButton.Checked then CloseHand else OpenHand;
        End
        Else Begin
          If SpuntoRobotHandForm.Visible then
             StopHand;
        End;
End;

procedure TSpuntoROBOTHandForm.StopHand;    // Stops the hand movement
Var
W,MyPortAddress:Word;
Begin
MYPortAddress:=FormPortaParallela.StepperMotorPortaParallela.SpuntoPortDataAddress;
        W:=0;                                // Bit Do e D1 della porta=0
        WritePort(MyPortAddress,W);
End;

procedure TSpuntoROBOTHandForm.CloseHand;    // Closes the hand
Var
W,MyPortAddress:Word;
Begin
MYPortAddress:=FormPortaParallela.StepperMotorPortaParallela.SpuntoPortDataAddress;
        W:=2;                                // Bit D1 della porta=1
        WritePort(MyPortAddress,W);
End;

procedure TSpuntoROBOTHandForm.OpenHand;    // Opens the Hand
Var
W,MyPortAddress:Word;
Begin
MYPortAddress:=FormPortaParallela.StepperMotorPortaParallela.SpuntoPortDataAddress;
        W:=1;                                // Bit D0 della porta=1
        WritePort(MyPortAddress,W);
End;

procedure TSpuntoROBOTHandForm.DelaytoStepTimerTimer(Sender: TObject);
begin
  HandAction;
end;

procedure TSpuntoROBOTHandForm.ContinuousMonitoringCheckBoxClick(
  Sender: TObject);
begin
   FormPortaParallela.StepperMotorPortaParallela.SpuntoContinuousMonitoring:=ContinuousMonitoringCheckBox.Checked;
If  ContinuousMonitoringCheckBox.Checked Then FormPortaparallela.Show else   FormPortaparallela.Hide;
end;

procedure TSpuntoROBOTHandForm.WritePort(PortAddress, PortData:word);
// Write PortData over PortAddress if Port Writing is enabled
begin
     PortData := (PortData*256)+PortData;
     asm
     Mov ax,PortData
     Mov dx,PortAddress
     Out dx,ax
     end;
 end;

procedure TSpuntoROBOTHandForm.MoveHandCheckBoxClick(Sender: TObject);
begin
   HandAction;
end;

procedure TSpuntoROBOTHandForm.OpenRadioButtonDblClick(Sender: TObject);
begin
   HandAction;
end;

procedure TSpuntoROBOTHandForm.CloseRadioButtonClick(Sender: TObject);
begin
    HandAction;
end;

procedure TSpuntoROBOTHandForm.Timer1Timer(Sender: TObject);
begin
    HandAction;
end;

end.
