package it.edmaster.eLisa;

import it.edmaster.eLisa.catalogo.*;
import it.edmaster.eLisa.ordini.*;
import it.edmaster.eLisa.utenti.*;

import it.edmaster.eLisa.common.*;
import it.edmaster.eLisa.util.*;

public class DAOLocator {
    
    public static DAOLocator instance = null;
    
    ApplicationContext context;
    CatalogoDAO catalogoDAO;
    UtentiDAO utentiDAO;
    OrdiniDAO ordiniDAO;
    CategoriaProdottoDAO categoriaProdottoDAO;
    
    private DAOLocator() {
        context = new ApplicationContext();
        
        catalogoDAO = new CatalogoDAO( context );
        categoriaProdottoDAO = new CategoriaProdottoDAO( context );
        utentiDAO = new UtentiDAO( context );
        ordiniDAO = new OrdiniDAO( context );
    }
    
    public static DAOLocator getInstance() {
        if( instance == null ) {
            instance = new DAOLocator();
        }
        return instance;
    }
    
    public CategoriaProdottoDAO getCategoriaProdottoDAO() {
        return categoriaProdottoDAO;
    }
    
    public CatalogoDAO getCatalogoDAO() {
        return catalogoDAO;
    }
    
    public UtentiDAO getUtentiDAO() {
        return utentiDAO;
    }
    
    public OrdiniDAO getOrdiniDAO() {
        return ordiniDAO;
    }
}
