package it.edmaster.eLisa.carrello;

import java.sql.*;
import java.util.*;

import it.edmaster.eLisa.*;
import it.edmaster.eLisa.catalogo.*;
import it.edmaster.eLisa.ordini.*;
import it.edmaster.eLisa.common.*;
import it.edmaster.eLisa.util.*;

public class Carrello {
    
    List prodotti;
    float totale = 0;

    /**
     * @link aggregation 
     */
    private Prodotto lnkProdotto;
    
    public Carrello() {
        prodotti = new LinkedList();
    }
    
    public void aggiungi( Prodotto prodotto ) {
        if( !prodotti.contains( prodotto ) ) {
            prodotti.add( prodotto );
            totale += prodotto.getPrezzoFinale();
            System.out.println( totale );
        }
    }
    
    public Iterator getElenco() {
        return prodotti.iterator();
    }
    
    public int getNumeroProdotti() {
        return prodotti.size();
    }
    
    public float getTotale() {
        return totale;
    }
    
    public void svuota() {
        prodotti.clear();
    }
    
    public void inoltraOrdine( String codiceUtente ) throws InserimentoOrdineException {
        OrdiniDAO dao = DAOLocator.getInstance().getOrdiniDAO();
        try {
            dao.inoltra( this, codiceUtente);
            svuota();
        } catch( SQLException se ) {
            throw new InserimentoOrdineException( se );
        }
    }
}
