package it.edmaster.eLisa.carrello;

import java.sql.*;
import java.util.*;

import it.edmaster.eLisa.*;
import it.edmaster.eLisa.catalogo.*;
import it.edmaster.eLisa.ordini.*;

import it.edmaster.eLisa.common.*;
import it.edmaster.eLisa.util.*;

public class CarrelloHelper {
    
    Carrello carrello;
    CatalogoHelper catalogoHelper;
    
    public CarrelloHelper( CatalogoHelper catalogoHelper ) {
        carrello = new Carrello();
        this.catalogoHelper = catalogoHelper;
    }
    
    public void aggiungi( String id ) throws CaricamentoProdottiException {
        if( id != null ) {
            catalogoHelper.setIdProdotto( id );
            Prodotto p = catalogoHelper.getProdotto();
            if( p != null ) {
                carrello.aggiungi( p );
            }
        }
    }
    
    public Iterator getElenco() {
        return carrello.getElenco();
    }
    
    public int getNumeroProdotti() {
        return carrello.getNumeroProdotti();
    }
    
    public float getTotale() {
        return carrello.getTotale();
    }
    
    public void svuota() {
        carrello.svuota();
    }
    
    public void inoltraOrdine( String codiceUtente ) throws InserimentoOrdineException {
        carrello.inoltraOrdine( codiceUtente );
    }
}
