package it.edmaster.eLisa.catalogo;

import java.sql.*;
import java.util.*;

import it.edmaster.eLisa.common.*;

public class CatalogoHelper {
    
    Catalogo catalogo;
    int inizio;
    int quanti;
    String ricerca;
    
    String idProdotto;
    
    String idCategoria;
    
    public CatalogoHelper() {
        catalogo = new Catalogo();
    }
    
    public void setInizio( String inizio ) {
        if (inizio != null) {
            this.inizio = (new Integer(inizio)).intValue();
        }
    }
    
    public void setQuanti( String quanti ) {
        if (quanti != null) {
            this.quanti = (new Integer(quanti)).intValue();
        }
    }
    
    public Pagina getPagina() throws CaricamentoProdottiException {
        Pagina pagina = null;
        
        if( idCategoria == null ) {
            pagina = catalogo.getElenco( inizio, quanti );
        } else {
            pagina = catalogo.getElenco( idCategoria, inizio, quanti );
        }
        
        return pagina;
    }
    
    public void setIdProdotto( String id ) {
        this.idProdotto = id;
    }
    
    public Prodotto getProdotto() throws CaricamentoProdottiException {
        return catalogo.getProdotto( idProdotto );
    }
    
    public int getInizio() {
        return inizio;
    }
    
    public List getCategorieProdotto() throws CaricamentoCategorieException {
        return catalogo.getCategorieProdotto();
    }
    
    public void setTestoDaCercare( String ricerca ) {
        this.ricerca = ricerca;
    }
    
    public Pagina getRisultatoRicerca() throws DataAccessException {
        return catalogo.cerca( ricerca, inizio, quanti );
    }
    
    public void setIdCategoria( String idCategoria ) {
        if( idCategoria.length() == 0 ) {
            idCategoria = null;
        }
        this.idCategoria = idCategoria;
    }
    
    public String getIdCategoria() {
        return idCategoria;
    }
}

