package it.edmaster.eLisa.catalogo;

import java.sql.*;
import java.util.*;

import it.edmaster.eLisa.common.*;
import it.edmaster.eLisa.util.Logger;

public class CategoriaProdottoDAO {
    ApplicationContext context;
    
    static List elenco = null;
    
    public CategoriaProdottoDAO( ApplicationContext context ) {
        this.context = context;
    }
    
    public List load() throws SQLException {
        if( elenco == null ) {
            String sql = "SELECT ID, CODICE, DESCRIZIONE FROM CATEGORIE_PRODOTTO ORDER BY ID";
            
            Connection conn = context.getConnection();
            Statement stmt = conn.createStatement( 
                ResultSet.TYPE_FORWARD_ONLY,
                ResultSet.CONCUR_READ_ONLY
            );
            ResultSet rs = stmt.executeQuery( Logger.logSql( sql ) );
            elenco = new LinkedList();
            
            while( rs.next() ) {
                int pos = 1;
                
                String id = rs.getString( pos++ );
                String codice = rs.getString( pos++ );
                String descrizione = rs.getString( pos++ );
                
                CategoriaProdotto cp = new CategoriaProdotto( id, codice, descrizione );
                elenco.add( cp );
            }
            
            rs.close();
            stmt.close();
            conn.close();
        }

        return elenco;
    }
    
}
