package it.edmaster.eLisa.catalogo;

import java.io.*;
import java.net.*;

import javax.servlet.*;
import javax.servlet.http.*;

public class ImageDownloadServlet extends HttpServlet {

    byte[] defaultImage;
    Catalogo catalogo;
    
	public void init(ServletConfig conf) throws ServletException {
		super.init(conf);
        
        catalogo = new Catalogo();
        
        try {
            loadDefaultImage( conf );
        } catch( IOException ex ) {
            ex.printStackTrace();
            throw new ServletException("Impossibile caricare l'immagine di default " + ex.getMessage() );
        }
	}

	public void doGet(HttpServletRequest req, HttpServletResponse res) throws IOException, ServletException {
		doPost( req, res );
	}

	public void doPost(HttpServletRequest req, HttpServletResponse res) throws IOException, ServletException {
        byte[] immagine = null;
        
        String id = req.getParameter("id");
        if( id != null ) {
            try {
                Prodotto prodotto = catalogo.getProdotto( id );
                immagine = prodotto.getImmagine();
            } catch( CaricamentoProdottiException ex ) {
                ex.printStackTrace();
                throw new RuntimeException("Impossibile caricare l'immagine del prodotto");
            }
        }
        
        immagine = (immagine==null) ? defaultImage : immagine;
        
        res.setContentType("image/jpeg");

        ServletOutputStream out = res.getOutputStream();
        out.write( immagine );
        out.close();
	}
    
    /**
     * Carica l'immagine dall'URL images/libro_generico.jpg
     * e la memorizza come attributo della servlet
     */
    void loadDefaultImage( ServletConfig conf ) throws IOException {
        int bytesRead = 0;
        byte byteArray[] = new byte[4096];
        ByteArrayOutputStream ba = new ByteArrayOutputStream();
        
        ServletContext context = conf.getServletContext();
        try {
            URL url = context.getResource("/images/libro_generico.jpg");
            InputStream in = url.openStream();
            
            while((bytesRead = in.read(byteArray)) != -1) {
                ba.write(byteArray, 0, bytesRead);
            }
            
            defaultImage = ba.toByteArray();
        } catch( MalformedURLException ex1 ) {
            ex1.printStackTrace();
            throw new RuntimeException( "Impossibile caricare l'immagine di default" );
        }
    }
}

