package it.edmaster.eLisa.utenti;

import java.sql.*;
import java.util.*;

import it.edmaster.eLisa.*;

public class ElencoUtenti {
    
    UtentiDAO dao = DAOLocator.getInstance().getUtentiDAO();

    /**
     * @link aggregation 
     */
    private Utente lnkUtente;
    
    public ElencoUtenti() {
    }
    
    public boolean autentica( String codiceUtente, String password ) throws CaricamentoUtentiException {
        boolean result = false;
        
        try {
            result = dao.autentica( codiceUtente, password );
        } catch( SQLException ex ) {
            throw new CaricamentoUtentiException( ex );
        }
        
        return result;
    }
    
    public List getElenco() throws CaricamentoUtentiException {
        List elenco = null;

        try {
            elenco = dao.getElenco();
        } catch( SQLException ex ) {
            throw new CaricamentoUtentiException( ex );
        }
        
        return elenco;
    }
    
    public Utente get( String codiceUtente ) throws CaricamentoUtentiException {
        Utente utente = null;

        try {
            utente = dao.get( codiceUtente );
        } catch( SQLException ex ) {
            throw new CaricamentoUtentiException( ex );
        }
        
        return utente;
    }
    
    public void inserisci( String codiceUtente, String password, String nome,
            String cognome) throws InserimentoUtentiException {
                
        try {
            dao.inserisci( codiceUtente, password, nome, cognome );
        } catch( SQLException ex ) {
            throw new InserimentoUtentiException( ex );
        }
    }
}

