package it.edmaster.eLisa.utenti;

import java.util.*;

/**
 * Indica l'impossibilit di recuperare gli utenti dal database
 */
public class InserimentoUtentiException extends Exception {
    
    public static String CODICE_UTENTE = "codiceUtente";
    public static String NOME = "nome";
    public static String COGNOME = "cognome";
    public static String PASSWORD1 = "password1";
    public static String PASSWORD2 = "password2";
    
    List campiErrati = new LinkedList();
    String campoCorrente;
    String message;
    
    public InserimentoUtentiException() {
        super();
    }
    
    public InserimentoUtentiException( String message ) {
        super( message );
    }
    
    public InserimentoUtentiException( Exception ex ) {
        super( ex );
    }
    
    public void addCampo( String codiceCampo ) {
        campiErrati.add( codiceCampo );
    }
    
    public Iterator getCampi() {
        return campiErrati.iterator();
    }
    
    public void setCodiceCampo( String campo ) {
        this.campoCorrente = campo;
        System.out.println("campo="+campo);
    }
    
    public boolean isInErrore() {
        if( campiErrati != null ) {
            boolean r = campiErrati.contains( campoCorrente );
            System.out.println("campiErrati="+campiErrati);
            System.out.println("r="+r);
            return r;
        } else {
            return false;
        }
    }
    
    public void setMessage( String message ) {
        this.message = message;
    }
    
    public String getMessage() {
        return message;
    }
}
