package it.edmaster.eLisa.util;

import java.sql.*;

public class JDBCUtils {
    
    public static void close( Connection conn ) {
        try {
            if( conn != null ) {
                conn.close();
            }
        } catch( SQLException ex ) {
            throw new RuntimeException( "Impossibile chiudere la connessione" );
        }
    }
    
    public static void close( Statement stmt ) {
        try {
            if( stmt != null ) {
                stmt.close();
            }
        } catch( SQLException ex ) {
            throw new RuntimeException( "Impossibile chiudere lo statement" );
        }
    }
    
    public static void close( ResultSet rs ) {
        try {
            if( rs != null ) {
                rs.close();
            }
        } catch( SQLException ex ) {
            throw new RuntimeException( "Impossibile chiudere il recordset" );
        }
    }
    
    public static void closeAll( Connection conn, Statement stmt  ) {
        closeAll( conn, stmt, null );
    }
    
    public static void closeAll( Connection conn, Statement stmt, ResultSet rs  ) {
        close( rs );
        close( stmt );
        close( conn );
    }
    
}
