<%--
--%>
<%@ page errorPage="../include/PaginaErrore.jsp" %>
<%@ taglib prefix='c' uri='http://java.sun.com/jstl/core' %>
<%@ taglib prefix='fmt' uri='http://java.sun.com/jstl/fmt' %>

<jsp:useBean
  id="catalogo"
  class="it.edmaster.eLisa.catalogo.CatalogoHelper"
  scope="session"
/>

<c:choose>
    <c:when test="${param.inizio != null}">
        <c:set value="${param.inizio}" target="${catalogo}" property="inizio"/>
        <c:set value="10" target="${catalogo}" property="quanti"/>
    </c:when>
    <c:otherwise>
        <c:set value="0" target="${catalogo}" property="inizio"/>
        <c:set value="10" target="${catalogo}" property="quanti"/>
    </c:otherwise>
</c:choose>

<%-- imposta l'eventuale filtro per categoria --%>
<c:set value="" target="${catalogo}" property="idCategoria"/>
<c:set var="operazioneElencoPerCategoria" value="catalogo.elencaPerCategoria"/>
<c:if test="${param.op==operazioneElencoPerCategoria}">
    <c:if test="${param.id != null}">
        <c:set value="${param.id}" target="${catalogo}" property="idCategoria"/>
    </c:if>
</c:if>

<c:choose>
    <%-- se il parametro testo  vuoto, vuol dire che non stiamo eseguendo una ricerca --%>
    <c:when test="${empty param.testo || param.testo.length == 0}">
        <c:set value="${catalogo.pagina}" var="paginaRisultati" />
    </c:when>
    
    <%-- in caso di ricerca, ne imposta i criteri nell'helper --%>
    <c:otherwise>
        <c:set value="${param.testo}" target="${catalogo}" property="testoDaCercare"/>
        <c:set value="${catalogo.risultatoRicerca}" var="paginaRisultati" />
    </c:otherwise>
</c:choose>

<HTML>
<HEAD>
    <TITLE>eLisa - Catalogo</TITLE>
    <LINK REL="stylesheet" HREF="css/default.css" TYPE="text/css"/>
</HEAD>    
<BODY MARGINHEIGHT="0" MARGINWIDTH="0" MARGINTOP="0" MARGINLEFT="0">
<jsp:include page="../include/testata.jsp" />

<TABLE BORDER="0" WIDTH="100%" CELLSPACING="0" CELLPADDING="5">
<TR>
    <TD WIDTH="20%" CLASS="sidebar"></TD>
    <TD WIDTH="60%">
        <c:if test="${param.testo == null}">
            <H1>Catalogo</H1>
        </c:if>
        <c:if test="${param.testo != null}">
            <H1>Risultato della ricerca</H1>
        </c:if>
    </TD>
    <TD WIDTH="20%" CLASS="sidebar"></TD>
</TR>

<TR>
    <TD CLASS="sidebar">
        <jsp:include page="../include/sinistra.jsp"/>
    </TD>
    <TD STYLE="padding: 20px">
    
    <c:if test="${param.testo != null}">
    <P>
    Hai cercato '<c:out value="${param.testo}" />'
    <P>
    </c:if>
    
<table border="0"
       width="100%"
       cellpadding="1"
       cellspacing="0">

<c:forEach var="item" items="${paginaRisultati.elenco}" varStatus="status">

    <c:set value="true" var="almenoUnElemento" />

    <%-- Inizia una nuova riga ogni due elementi --%>
    <c:if test="${status.count % 2 == 1}">
        <tr>
    </c:if>
    
    <%-- Costruisce il link al dettaglio del prodotto --%>
    <c:set var="link" value="<A HREF=controller?op=catalogo.dettagliProdotto&id=${item.id}>"/>
    
    <c:if test="${status.count <= 2 && param.testo == null}">
    <td WIDTH="50%">
        
        <c:out value="${link}" escapeXml="false" />
        <IMG SRC="immagine?id=<c:out value="${item.id}" />" BORDER="0" ALIGN="left"/>
        <c:out value="${item.nome}" /><BR>
        </A>
        <c:out value="${item.descrizioneCorta}" />
        <c:out value="${link}" escapeXml="false" />[continua]</A>
        <P>
        <B>
        Prezzo: euro <c:out value="${item.prezzo}" /><BR>
        IVA: <c:out value="${item.iva.descrizione}" /><BR>
        Sconto: <c:out value="${item.sconto}" />%<BR>
        </B>
        <P>
    </td>
    </c:if>

    <c:if test="${status.count > 2 || param.testo != null}">
    <td WIDTH="50%">
        <c:out value="${link}" escapeXml="false" />
        <c:out value="${item.nome}" /><BR>
        </A>
        <c:out value="${item.descrizioneCorta}" />
        <c:out value="${link}" escapeXml="false" />[continua]</A>
        <P>&nbsp;
    </td>
    </c:if>
    
    <%-- Conclude la nuova riga ogni due elementi --%>
    <c:if test="${status.count % 2 == 0}">
        </tr>
    </c:if>
</c:forEach>

<c:if test="${!almenoUnElemento}">
Non ho trovato nessun prodotto che corrisponda ai parametri di ricerca indicati.
</c:if>

</table>

    <TABLE BORDER="0" WIDTH="100%" CLASS="catalogo-navigazione">
    <TR>
        <TD WIDTH="25%">
            <c:if test="${catalogo.inizio>1}">
                <c:url value="/controller" var="indietroUrl">
                    <c:param name="op" value="${param.op}"/>
                    <c:param name="inizio" value="${catalogo.inizio-10}"/>
                    <c:if test="${!empty param.id}">
                        <c:param name="id" value="${param.id}"/>
                    </c:if>
                </c:url>
                
                <A HREF="<c:out value="${indietroUrl}"/>">Indietro</A>
            </c:if>
            &nbsp;
        </TD>
        <TD WIDTH="50%" ALIGN="center">
        Pagina <fmt:formatNumber value="${(catalogo.inizio/10)+1}" pattern="###"/>
        </TD>
        <TD WIDTH="25%" ALIGN="right">
            &nbsp;
            <c:if test="${paginaRisultati.next}">
                <c:url value="/controller" var="avantiUrl">
                    <c:param name="op" value="${param.op}"/>
                    <c:param name="inizio" value="${catalogo.inizio+10}"/>
                    <c:if test="${!empty param.id}">
                        <c:param name="id" value="${param.id}"/>
                    </c:if>
                </c:url>
                
                <A HREF="<c:out value="${avantiUrl}"/>">Avanti</A>
            </c:if>
        </TD>
    </TR>
    </TABLE>

    </TD>
    
    <TD CLASS="sidebar">
        <jsp:include page="../include/destra.jsp"/>
    </TD>
</TR>

<jsp:include page="../include/piede.jsp" />

</BODY>
</HTML>
