package cap04;

import java.io.*;
import java.sql.*;

public class BlobTest {
    
    public static final int BUFFER_SIZE = 4096;
    protected Connection conn;
    
    public BlobTest() {
        try {
            connect();
            
            dropTable();
            createTable();
            insertValues();
            
            conn.close();
            
        } catch( Exception ex ) {
            ex.printStackTrace();
        }
    }
    protected void connect() throws ClassNotFoundException, InstantiationException, 
            IllegalAccessException, SQLException {
        Class.forName("com.mysql.jdbc.Driver").newInstance();
        conn = DriverManager.getConnection("jdbc:mysql:///prova?user=max&password=max");
    }
    
    protected void dropTable() {
        try {
            String sql = "DROP TABLE blob_test";
            System.out.println( sql );
            
            Statement stmt = conn.createStatement();
            stmt.execute( sql );
            stmt.close();
        } catch( SQLException ex ) {
            System.err.println("La tabella 'blob_test' non esiste");
            ex.printStackTrace();
        }
    }
    
    protected void createTable() throws SQLException {
        String sql = "CREATE TABLE blob_test ("+
            "id int(11) NOT NULL auto_increment,"+
            "blob_field LONGBLOB,"+
            "PRIMARY KEY  (id)"+
            ") ";
        System.out.println( sql );

        Statement stmt = conn.createStatement();
        stmt.execute( sql );
        stmt.close();
    }
    
    protected void insertValues() throws SQLException, IOException {
        String sql = "INSERT INTO blob_test (blob_field) VALUES (?)";
        System.out.println( sql );
        
        PreparedStatement stmt = conn.prepareStatement(sql);
        
        stmt.setBytes(1, loadTestFile());
        int count = stmt.executeUpdate();
        System.out.println("Inserito count="+count);
        
        stmt.close();
    }
    
    protected byte[] loadTestFile() throws IOException {
        int lungh;
        byte[] buf = new byte[BUFFER_SIZE];

        FileInputStream in = new FileInputStream("build.xml");
        ByteArrayOutputStream contenuto = new ByteArrayOutputStream(BUFFER_SIZE);
        
        while(true) {
            lungh = in.read(buf);
            if(lungh == -1){
                break;
            }
            contenuto.write(buf,0,lungh);
        }
        
        return contenuto.toByteArray();
    }
    
    public static void main( String[] args ) {
        new BlobTest();
    }    
}
